/*
 * Copyright 2016 Alexander Baumgartner
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package at.jku.risc.stout.urmc.algo;

public class MatchSystemCollection {
	private MatchSystem first;

	public boolean isEmpty() {
		return first == null;
	}

	public void add(MatchSystem sys) {
		sys.setNext(first);
		first = sys;
	}

	public MatchSystem remove() {
		MatchSystem sys = first;
		first = sys.getNext();
		return sys;
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append('{');
		for (MatchSystem sys = first; sys != null; sys = sys.getNext())
			sb.append(sys).append(", ");
		if (!isEmpty())
			sb.setLength(sb.length() - 2);
		sb.append('}');
		return sb.toString();
	}
}
